--[[

MultiAddOn by Interceptor

Darf in anderen Foren geposted werden, mit der Vorraussetzung: Verlinkung auf Original-Thread!

Private nderungen sind erlaubt!
Habe nichts gegen eine Verffentlichung eines genderten Scripts, bitte nennt aber dann den Urheber des eigentlichen Scripts!

Danke!


Besonderer Dank geht an meine Tester, allen voran "Andreas572"! 


Gru, Interceptor

]]

MultiAddOn = {};



function MultiAddOn:load()

self.implementhash = {}; 
self.implementname  = {};
self.oldImplement  = {};
self.currentImplement  = {};

	if self.name == nil then self.name = "NoName" end
	if self.MAname == nil then self.MAname =  string.gsub (self.name, " " , "_") end
	repeat 
		if MAexist == nil then
				print ("MultiAddOn.xml laden")
				MultiAddOnXMLid = loadXMLFile("MAxml", getUserProfileAppPath().."/ModShare/MultiAddOn/MultiAddOn.xml")
				MAexist = Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.global.exist"), false)
				allowshowoffset = Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.alternateThreshing.ShowOffset"),true)
			elseif MAexist and not MA1stload then
				source (g_modsDirectory.."/zzz_MultiAddOn/alternateThreshing.lua")
				source (g_modsDirectory.."/zzz_MultiAddOn/global.lua")
				source (g_modsDirectory.."/zzz_MultiAddOn/realignDirection.lua")
				source (g_modsDirectory.."/zzz_MultiAddOn/editTractorImplementAiMarker.lua")
				if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.globals"), true) then MAglobal1() end
				print ("MultiAddOn.xml geladen")
				MA1stload = true 
			elseif MAexist == false then
				createFolder (getUserProfileAppPath().."/ModShare")
				createFolder (getUserProfileAppPath().."/ModShare/MultiAddOn")
				MultiAddOnXMLid = createXMLFile("MAxml", getUserProfileAppPath().."/ModShare/MultiAddOn/MultiAddOn.xml", "MultiAddOn")
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.global.exist", true)
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.alternateThreshing.ShowOffset", true)
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing", true) 
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.realignDirection", true)
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.globals", true)
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.editNightLight", true)
				setXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.editAiMarkerTractor", true)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.MaxHirable", g_currentMission.maxNumHirables)
				setXMLFloat (MultiAddOnXMLid, "MultiAddOn.global.LightsOff", 7)
				setXMLFloat (MultiAddOnXMLid, "MultiAddOn.global.LightsOn", 20)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.manure",g_manureLitersPerCowPerDay)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.milkLiters", g_milkLitersPerCowPerDay)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.chaff", g_chaffPerCowPerDay)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.grass", g_grassPerCowPerDay)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.liquidManureLiters", g_liquidManureLitersPerCowPerDay)
				setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.cows.milkingPlaceMilk", g_milkingPlaceMilkPerCow)
				MAexist = true
				saveXMLFile(MultiAddOnXMLid) print ("MultiAddOn.xml wird erstellt") 
		end
	until MA1stload

	if self.grainTankCapacity then self.presstimer = 60 self.presstimer2 = 60
		if not self.hash then
			for k in pairs (g_currentMission.missionDynamicInfo.mods) do
				if g_currentMission.missionDynamicInfo.mods[k].modDir == self.baseDirectory then self.hash = g_currentMission.missionDynamicInfo.mods[k].fileHash break else self.hash = "NoMod" end
			end
		end
		self.aiOffset = Utils.getNoNil(getXMLFloat(MultiAddOnXMLid, "MultiAddOn.alternateThreshing.Offset."..self.MAname..".Hash."..self.hash.."#aiOffset", self.aiOffset),3)
		self.newoffset = self.aiOffset
	end
end

function MultiAddOn:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if self.grainTankCapacity then
	self.alternateThreshingRoundsRemaining = Utils.getNoNil(getXMLFloat(xmlFile, key.."#MAroundsRemaining"),0);
		if self.alternateThreshingRoundsRemaining > 0 then self.alternateThreshing = true end
	end
end

function MultiAddOn:getSaveAttributesAndNodes(nodeIdent)
	if self.grainTankCapacity then
		setXMLInt (MultiAddOnXMLid, "MultiAddOn.global.MaxHirable", g_currentMission.maxNumHirables)
		setXMLBool (MultiAddOnXMLid, "MultiAddOn.alternateThreshing.ShowOffset", allowshowoffset)
		setXMLFloat(MultiAddOnXMLid, "MultiAddOn.alternateThreshing.Offset."..self.MAname..".Hash."..self.hash.."#aiOffset", self.aiOffset)
		saveXMLFile(MultiAddOnXMLid)

		local attributes = 'MAroundsRemaining="'..Utils.getNoNil(self.alternateThreshingRoundsRemaining,0)..'"'
		return attributes
	end
end

function MultiAddOn:update()

	if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing"), true) then
		if self.alternateThreshing then
			AlternateThreshing(self)
		end
	else self.alternateThreshing = false
	end
		
		
		
	if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.editNightLight"), true) then MAglobal2() end
	

	
	
end

function MultiAddOn:draw()
	
	if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing"), true) then
		if self.grainTankCapacity then
			if getXMLFloat(MultiAddOnXMLid, "MultiAddOn.alternateThreshing.Offset."..self.MAname..".Hash."..self.hash.."#aiOffset") == nil then allowshowoffset = true end
		end
	
		if self.showoffset then
			renderText(0.2, 0.55, 0.03125, "aiOffset:")
			renderText(0.2, 0.5, 0.03125, string.format ("%q", self.newoffset))
		end

		if self.alternateThreshing then
			if self.alternateThreshingRoundsRemaining == 0 then self.kursart = "O" else self.kursart = "O x "..self.alternateThreshingRoundsRemaining end
			if InputBinding.hasEvent(InputBinding.MultiAddOn) then self.alternateThreshingRoundsRemaining = self.alternateThreshingRoundsRemaining + 0.25 end
			else self.kursart = "||"
			self.alternateThreshingRoundsRemaining = 0
		end	
	end
	if self.showMAdir and Utils.getNoNil(self.alternateThreshingRoundsRemaining,0) > 0 and self.isAIThreshing then
	
		if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing"), true) then self.makenewcourse = true end
		
		elseif InputBinding.hasEvent(InputBinding.MultiAddOn) and self.isAIThreshing and Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing"), true) then self.makenewcourse = true
		elseif InputBinding.hasEvent(InputBinding.MultiAddOn) and self.isAITractorActivated and Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.realignDirection"), true) then self.makenewcourse = true
	end
	
	
	if self.makenewcourse then 
		RealignDirection(self)
	end
	
	if self.isAIThreshing or self.isAITractorActivated then
		if self.isAITractorActivated then
			if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.editAiMarkerTractor"), true) then	editTractorImplementAiMarker(self) end
			
			if self.aiTractorDirectionX == 1 or self.aiTractorDirectionX == 0 or self.aiTractorDirectionX == -1 then self.showMAdir = false
				else
				if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.realignDirection"), true) then self.showMAdir = true end
			end
			
		end
	end
	if self.showMAdir and Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.realignDirection"), true) then g_currentMission:addHelpButtonText("Helfer ausrichten", InputBinding.MultiAddOn) end
	if Utils.getNoNil(getXMLBool (MultiAddOnXMLid, "MultiAddOn.useMAparts.alternateThreshing"), true) then
		if self.grainTankCapacity and self.isAIThreshing then
			if self.aiThreshingDirectionX == 1 or self.aiThreshingDirectionX == 0 or self.aiThreshingDirectionX == -1 then
				if self.aiThreshingDirectionZ == 1 or self.aiThreshingDirectionZ == 0 or self.aiThreshingDirectionZ == -1 then
					g_currentMission:addHelpButtonText("Kursart: "..self.kursart, InputBinding.MultiAddOn) self.showMAdir = false
					if InputBinding.isPressed(InputBinding.MultiAddOn) and self.presstimer == 0 then self.alternateThreshing = not self.alternateThreshing self.presstimer = 60 self.alternateThreshingRoundsRemaining = 0
						elseif InputBinding.isPressed(InputBinding.MultiAddOn) and self.presstimer ~= 0 then self.presstimer = self.presstimer - 1
						elseif not InputBinding.isPressed(InputBinding.MultiAddOn) then self.presstimer = 60 end
			
				end
			else self.showMAdir = true
			end
	
		end
	
	
		if allowshowoffset then
		ShowOffset(self)
		end
	end

	
end	


function MultiAddOn:delete()
end;

function MultiAddOn:mouseEvent(posX, posY, isDown, isUp, button)
end	

function MultiAddOn:keyEvent(unicode, sym, modifier, isDown)

end;


